//+------------------------------------------------------------------+
//|                                                         Junr.mq4 |
//|                        Copyright 2022, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   2

#property indicator_type1  DRAW_LINE
#property indicator_label1 "Junr Up"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

#property indicator_type2  DRAW_LINE
#property indicator_label2 "Junr Down"
#property indicator_color2 clrRed
#property indicator_width2 1
#property indicator_style2 STYLE_SOLID

input ushort iLength=24;

double bufferH[],bufferL[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,bufferH,INDICATOR_DATA);
   ArraySetAsSeries(bufferH,true);

   SetIndexBuffer(1,bufferL,INDICATOR_DATA);
   ArraySetAsSeries(bufferL,true);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(close,true);

   int bars=prev_calculated>0? rates_total-prev_calculated:rates_total-iLength-1;

   for(int i=bars; i>=0; i--)
     {
      double sumH=0,sumL=0;
      for(int j=0; j<iLength; j++)
        {
         int pos=i+j;
         double o=open[pos],c=close[pos],max=MathMax(o,c),min=MathMin(o,c);
         sumH=sumH+max;
         sumL=sumL+min;
        }

      bufferH[i]=sumH/iLength;
      bufferL[i]=sumL/iLength;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
